import path from 'path';
import llvm from '..';

const filename = path.basename(__filename);
const context = new llvm.LLVMContext();
const module = new llvm.Module("demo", context);
const builder = new llvm.IRBuilder(context);

const returnType = builder.getVoidTy();
const functionType = llvm.FunctionType.get(returnType, false);
const parent = llvm.Function.Create(functionType, llvm.Function.LinkageTypes.ExternalLinkage, 'issue13', module);

const init = llvm.BasicBlock.Create(context, "init", parent);
builder.SetInsertPoint(init)
builder.CreateAlloca(builder.getInt64Ty(), null, 'alloca')
builder.CreateRetVoid();

if (llvm.verifyFunction(parent)) {
    console.error(`${filename}: verifying the 'add' function failed`);
    process.exit(1);
}
if (llvm.verifyModule(module)) {
    console.error(`${filename}: verifying the module failed`);
    process.exit(1);
}

console.log(module.print());